<!DOCTYPE html>
<html lang="no">
<head>
    <meta charset="utf-8">
    <title>Demografiske data</title>
    <link rel="stylesheet" type="text/css" href="style.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    <?php
    include 'functions.inc.php';
    ?>
</head>
<body>
<div class="container" id="content">
<a href='index.php'>Tilbake til forsiden</a><br>
<?php
    # Lagrer fornavn, farsnavn og fødselsår for å bruke videre ut ifra hvordan brukeren vil håndtere personen
    $fornavn = "";
    $farsnavn = "";
    $fodselsaar = "";
    $kjonn = "";
    $linkUsikre = "";
    $kildeType = "";
    $kildeID = "";

    # Sjekker om brukeren vil linke personer fra tabellen usikker, eller bare kildepersoner
    if(isset($_GET["linkUsikre"])){
        if($_GET["linkUsikre"]=="ja"){
            $linkUsikre = "ja";
        }
    }

    # Håndterer link til eksisterende person og oppdatering av tomme felter
    if(isset($_GET["PersonID"]) and isset($_GET["KildeID"])){
        $personID = $_GET["PersonID"];
        $kildeID = $_GET["KildeID"];
        $sql = "INSERT INTO personkildekobling(PersonID, KildePersonID) VALUES ($personID, $kildeID);";
        $result = $connection-> query($sql);

        # Personen i personer kan ha manglende info som den nye kilden har. Derfor henter vi ut verdiene fra kilden og oppdaterer de blanke feltene hos personen.
        $sql = "SELECT Fornavn, Farsnavn, Etternavn, Kjonn, FodselsDag, FodselsMnd, FodselsAar FROM personerfrakilder WHERE ID = $kildeID";

        $result = $connection-> query($sql);
        $row = $result-> fetch_assoc();

        $fornavn = $row["Fornavn"];
        $farsnavn = $row["Farsnavn"];
        $etternavn = $row["Etternavn"];
        $kjonn = $row["Kjonn"];
        $fDag = $row["FodselsDag"];
        $fMnd = $row["FodselsMnd"];
        $fAar = $row["FodselsAar"];

        $sql = "UPDATE personer
            SET
            Fornavn = IF(Fornavn IS NULL, '$fornavn', Fornavn),
            Farsnavn = IF(Farsnavn IS NULL, '$farsnavn', Farsnavn),
            Etternavn = IF(Etternavn IS NULL, '$etternavn', Etternavn),
            Kjonn = IF(Kjonn IS NULL, '$kjonn', Kjonn),
            FodselsDag = IF(FodselsDag IS NULL, '$fDag', FodselsDag),
            FodselsMnd = IF(FodselsMnd IS NULL, '$fMnd', FodselsMnd),
            FodselsAar = IF(FodselsAar IS NULL, '$fAar', FodselsAar)
            WHERE ID = $personID";
        $result = $connection-> query($sql);

        #  Fjerner personen fra usikker hvis de var der
        if($linkUsikre == "ja"){
            $sql = "DELETE FROM usikker WHERE KildeID = $ID";
            $result = $connection-> query($sql);
        }

        header("Location: link.php?linkUsikre=$linkUsikre");            
        
    }
    
    if(isset($_GET["usikker"])){
        $usikker = $_GET["usikker"];
        $sql = "INSERT INTO usikker(KildeID) VALUES ($usikker);";
        $result = $connection-> query($sql);
        header("Location: link.php");            
        
    }
    

    # Henter 1 person som ikke er linket fra før
    if($linkUsikre == "ja"){
        $sql = "SELECT * FROM personerfrakilder WHERE ID IN (SELECT KildeID FROM usikker) LIMIT 1";
    }
    else{
        $sql = "SELECT * FROM personerfrakilder WHERE ID NOT IN (SELECT KildePersonID FROM personkildekobling) AND ID NOT IN (SELECT KildeID FROM usikker) LIMIT 1";
    }
    $result = ($connection-> query($sql));
    if($result-> num_rows > 0) {
        echo "<h1>Kilde</h1>";
        echo antallLinket();
        echo "<table class='table table-striped table-bordered table-responsive'>";
        echo "<th></th>";    
        tableHeader("personerfrakilder");
        while($row = $result-> fetch_assoc()) {
            echo "<tr>";

            # Legger til link som lar brukeren se den fulle kilden personen er fra
            $table = $row["KildeType"];
            $ID = $row["KildeID"];
            $link = "result.php?table=$table&ID=$ID";
            echo "<td><a href='$link' class='btn btn-secondary'>Se kilden</a></td>";
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
            echo "</tr>";
            $fornavn = $row["Fornavn"];
            $farsnavn = $row["Farsnavn"];
            $fodselsaar = $row["FodselsAar"];
            $kjonn = $row["Kjonn"];
            $kildeID = $row["ID"];
            $kID = $row["KildeID"];
            $kildeType = $row["KildeType"];
        }
        echo "</table>";
    }
    else {
        echo "Alle kildene har blitt linket.";
        header("Location: index.php");                    
    }

    # Knapper

    echo "<br>";
    echo "<div class='row'>";

    # Knappen for usikre skal ikke vises dersom kilden er usikker fra før
    if($linkUsikre != "ja"){
        echo "<div class='col-sm text-center'>";
        # Lar brukeren registrere personen som en ny person. Brukeren bli da sendt til nyPerson.php
        echo "<a href='link.php?usikker=$kildeID' class='btn btn-warning'>Usikker</a><br>";

        echo "</div>";
    }

    # Dersom brukeren er usikker kan de derimot hoppe over personen, som da blir lagt til en liste over personer som er hoppet over.
    echo "<div class='col-sm text-center'>";
    echo "<a href='nyPerson.php?ID=$kildeID&linkUsikre=$linkUsikre' class='btn btn-success'>Ny person</a>";
    echo "</div>";
    echo "</div>";

    # Familieoversikt hvis kilden er en folketelling. 
    # Alle folketellingene har "no_" i starten av kildetypen, så dette kan brukes for å teste om kilden er en folketelling.
    # Deretter henter vi alle kildene som har matchende kommune, tellekrets og løpenummer som kilden. Disse vil være fra samme familie, som kan hjelpe brukeren i linkingen.
    if(strpos($kildeType, 'no_') !== false){
        echo "<h1>Familie</h1>";
        $sql = "SELECT ID, Kjonn, Fornavn, Farsnavn, Etternavn, FodselsAar FROM $kildeType WHERE Kommune IN (SELECT Kommune FROM $kildeType WHERE ID = $kID) AND Tellekrets IN (SELECT Tellekrets FROM $kildeType WHERE ID = $kID) AND Lopenr IN (SELECT Lopenr FROM $kildeType WHERE ID = $kID) AND ID != $kID";
        
        $result = ($connection-> query($sql)); 
        if($result-> num_rows > 0) {
            echo "<table class='table table-striped table-bordered table-responsive'>";
            echo "<th></th>";
            echo "<th>ID</th>";
            echo "<th>Kjonn</th>";
            echo "<th>Fornavn</th>";
            echo "<th>Farsnavn</th>";
            echo "<th>Etternavn</th>";
            echo "<th>FodelsAar</th>";
            echo "<tr>";
            while($row = $result-> fetch_assoc()) {
                $ID = $row["ID"];
                $link = "result.php?table=$kildeType&ID=$ID";
                echo "<td><a href='$link' class='btn btn-secondary'>Se kilden</a></td>";

                foreach ($row as &$value) {
                    echo "<td>" . $value . "</td>";
                }
                echo "</tr>";
            }
            echo "</table><br>";
        }
        else {
            
                echo "Ingen resultater.";
            
        }
    }


    # Henter personer fra tabellen 'personer', og foreslår de mest like personene til brukeren
    echo "<h2>Personer</h2>";

    # Regner ut levenshtein-avstanden mellom fornavnet til kilden og fornavnet til personen, gjør det samme med farsnavnet og sorterer resultatene etter summen av disse.
    $sql = 
        "SELECT *, (levenshtein(Fornavn, '$fornavn') + levenshtein(Farsnavn, '$farsnavn')) as avstand FROM personer 
        WHERE 
        (LEFT(FodselsAar, 4) = LEFT('$fodselsaar', 4) 
        OR FodselsAar = '' 
        OR '$fodselsaar' = '' 
        OR IF((levenshtein(Fornavn, '$fornavn') + levenshtein(Farsnavn, '$farsnavn')) < 2, TRUE, FALSE)) 
        AND (NOT(fornavn IS NULL AND Farsnavn IS NULL AND FodselsAar IS NULL) 
        AND Kjonn = '$kjonn')
        ORDER BY avstand ASC 
        LIMIT 100";
    # echo $sql;
    $result = ($connection-> query($sql)); 
    if($result-> num_rows > 0) {
        echo "<table class='table table-striped table-bordered' table-responsive'>";
        echo "<th>Kilde</th>";
        tableHeader("personer");
        echo "<th><u>Likhet</u></th>";
        echo "<th>Link</th>";
        while($row = $result-> fetch_assoc()) {
            echo "<tr>";
            $ID = $row["ID"];
            echo "<td><a href='showLinks.php?ID=$ID' class='btn btn-secondary'>Se linker</a></td>";   
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
            echo "<td><a href='link.php?PersonID=$ID&KildeID=$kildeID&linkUsikre=$linkUsikre' class='btn btn-success'>Link</a></td>";
            echo "</tr>";
        }
        echo "</table><br>";
    }
    else {
        
            echo "Ingen resultater.";
        
    }
    
?>
</div>
</body>
</html>






