<!DOCTYPE html>
<html lang="no">
<head>
    <meta charset="utf-8">
    <title>Demografiske data</title>
    <link rel="stylesheet" type="text/css" href="style.css">    
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
</head>
<body>
<div class="container" id="content">
<a href='index.php'>Tilbake til forsiden</a>
<?php 
include 'functions.inc.php';
if(!empty($_POST["kilder"])){
    $personID = $_GET["ID"];
    $kilder = $_POST["kilder"];
    for($i = 0; $i < count($kilder); $i++){

        #Linker person med kilde
        #$personID = $_GET["PersonID"];
        $kildeID = $kilder[$i];
        $sql = "INSERT INTO personkildekobling(PersonID, KildePersonID) VALUES ($personID, $kildeID);";
        $result = $connection-> query($sql);
        echo $sql;

        #Personen i personer kan ha manglende info som den nye kilden har. Derfor henter vi ut verdiene fra kilden og oppdaterer de blanke feltene hos personen.
        $sql = "SELECT Fornavn, Farsnavn, Etternavn, Kjonn, FodselsDag, FodselsMnd, FodselsAar FROM personerfrakilder WHERE ID = $kildeID";

        $result = $connection-> query($sql);
        $row = $result-> fetch_assoc();

        $fornavn = $row["Fornavn"];
        $farsnavn = $row["Farsnavn"];
        $etternavn = $row["Etternavn"];
        $kjonn = $row["Kjonn"];
        $fDag = $row["FodselsDag"];
        $fMnd = $row["FodselsMnd"];
        $fAar = $row["FodselsAar"];

        $sql = "UPDATE personer
            SET
            Fornavn = IF(Fornavn IS NULL, '$fornavn', Fornavn),
            Farsnavn = IF(Farsnavn IS NULL, '$farsnavn', Farsnavn),
            Etternavn = IF(Etternavn IS NULL, '$etternavn', Etternavn),
            Kjonn = IF(Kjonn IS NULL, '$kjonn', Kjonn),
            FodselsDag = IF(FodselsDag IS NULL, '$fDag', FodselsDag),
            FodselsMnd = IF(FodselsMnd IS NULL, '$fMnd', FodselsMnd),
            FodselsAar = IF(FodselsAar IS NULL, '$fAar', FodselsAar)
            WHERE ID = $personID";
        $result = $connection-> query($sql);

        $sql = "DELETE FROM usikker WHERE KildeID = $kildeID";
        $result = $connection-> query($sql);
        $neste = $personID + 1;
        header("Location: linkPerson.php?ID=$neste");                    
    }
}
if (!empty($_GET["ID"])) {

    $personID = $_GET["ID"];

    $sql = "SELECT * FROM personer WHERE ID = $personID";

    #Navigasjonsknapper
    echo "<div class='row'>";
    echo "<div class='col-sm text-center'>";
    $forrige = $personID - 1;
    $neste = $personID + 1;
    echo "<a href='linkPerson.php?ID=$forrige' class='btn btn-secondary'>&larr; Forrige person</a>";
    echo " ";
    echo "<a href='linkPerson.php?ID=$neste' class='btn btn-secondary'>Neste person &rarr;</a>";
    echo "</div>";
    echo "</div>";


    echo "<h2>Person</h2>";    
    echo antallLinket();
    


    $result = ($connection-> query($sql));

    if($result-> num_rows > 0) {
        echo "<table class='table table-striped table-bordered'>";
        echo "<th></th>";
        tableHeader("personer");

        while($row = $result-> fetch_assoc()) {
            echo "<tr>";
            echo "<td><a href='showLinks.php?ID=$personID' class='btn btn-secondary'>Se linker</a></td>";   
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
            echo "</tr>";
            $fornavn = $row["Fornavn"];
            $farsnavn = $row["Farsnavn"];
            $fodselsaar = $row["FodselsAar"];
            $kjonn = $row["Kjonn"];
            echo "</table>";
        }
    }
    else {
        header("Location: linkPerson.php?ID=1");            
    }    

    echo "<form action='linkPerson.php?ID=$personID' method='post'>";

    echo "<div class='row'>";
    echo "<div class='col-sm text-center'>";

    echo "<input type='submit' value='Link valgte kilder' class='btn btn-success' />";
    echo "</div>";
    echo "</div>";
        
        
        
    #Henter personer fra tabellen 'personer', og foreslår de mest like personene til brukeren
    echo "<h2>Kilder</h2>";

    #Regner ut levenshtein-avstanden mellom fornavnet til kilden og fornavnet til personen, gjør det samme med farsnavnet og sorterer resultatene etter summen av disse.
    $sql = 
        "SELECT *, (levenshtein(Fornavn, '$fornavn') + levenshtein(Farsnavn, '$farsnavn')) as avstand FROM personerfrakilder 
        WHERE 
        (LEFT(FodselsAar, 4) = LEFT('$fodselsaar', 4) 
        OR FodselsAar = '') 
        AND NOT(fornavn IS NULL AND Farsnavn IS NULL AND FodselsAar IS NULL) 
        AND Kjonn = '$kjonn'
        AND ID NOT IN (SELECT KildePersonID FROM personkildekobling)
        ORDER BY avstand ASC 
        LIMIT 100";
    $result = ($connection-> query($sql)); 
    if($result-> num_rows > 0) {
        echo "<table class='table table-striped table-bordered table-responsive table-body'>";
        echo "<th>Kilde</th>";
        echo "<th>Link</th>";
        tableHeader("personerfrakilder");
        echo "<th><u>Likhet</u></th>";
        while($row = $result-> fetch_assoc()) {
            echo "<tr>";
            $kildeID = $row["KildeID"];
            $ID = $row["ID"];
            $table = $row["KildeType"];

            # Sjekker om kilden er en folketelling. Dersom den er det blir linken "Se kilden" endret til å vise de personene fra folketellingen som har samme kommunenr, tellekretsnr og løpenr som personen.
            if(strpos($table, 'no_') !== false){
                $sql = "SELECT Kommune, Tellekrets, Lopenr FROM $table WHERE ID = $kildeID";
                $resultat = ($connection-> query($sql));
                while($rad = $resultat-> fetch_assoc()){
                    $kommune = $rad["Kommune"];
                    $tellekrets = $rad["Tellekrets"];
                    $lopenr = $rad["Lopenr"];
                    echo "<td><a href='result.php?table=$table&Kommune=$kommune&Tellekrets=$tellekrets&Lopenr=$lopenr' class='btn btn-secondary'>Se kilden</a></td>";   
                };
            }            
            else {
                echo "<td><a href='result.php?table=$table&ID=$kildeID' class='btn btn-secondary'>Se kilden</a></td>";   
            }
            echo "<div class='checkbox'>";
            echo "<td><input type='checkbox' name='kilder[]' value='$ID' /></td>";
            echo "</div>";
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
            echo "</tr>";
        }
        echo "</table><br>";
    }
    else {
        
            echo "Ingen resultater.";
        
    }

    echo "</form>";

}
else {}
?>
</div>
</body>
</html>




