<!DOCTYPE html>
<html lang="no">
<head>
    <meta charset="utf-8">
    <title>Demografiske data</title>
    <link rel="stylesheet" type="text/css" href="style.css">    
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
</head>
<body>
<div class="container" id="content">
<a href='index.php'>Tilbake til forsiden</a>
<?php 
include 'functions.inc.php';
if (!empty($_GET)) {

    $PersonID = $_GET["ID"];

    $sql = "SELECT * FROM personer WHERE ID = $PersonID";


    echo "<h2>Person</h2>";    


    $result = ($connection-> query($sql));

    if($result-> num_rows > 0) {
    echo "<table class='table table-striped table-bordered'>";
    tableHeader("personer");

    while($row = $result-> fetch_assoc()) {
        echo "<tr>";
        foreach ($row as &$value) {
            echo "<td>" . $value . "</td>";
        }
        echo "</tr>";
        echo "</table>";
    }
    }
    else {
    echo "Ingen resultater.";
    }    

    $sql = "SELECT * FROM personerfrakilder WHERE ID IN (SELECT KildePersonID FROM personkildekobling WHERE PersonID = '$PersonID')";

    echo "<h3>Kilder</h3>";    


    $result = ($connection-> query($sql));

    if($result-> num_rows > 0) {
        echo "<table class='table table-striped table-bordered'>";
        echo "<th></th>";    
        tableHeader("personerfrakilder");

        while($row = $result-> fetch_assoc()) {
            echo "<tr>";
            $table = $row["KildeType"];
            $ID = $row["KildeID"];
            $link = "result.php?table=$table&ID=$ID";
            echo "<td><a href='$link' class='btn btn-secondary'>Se kilden</a></td>";
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
        echo "</tr>";
        }
        echo "</table>";
    
    }
    else {
        echo "Ingen kilder.";
    }
    echo "<br>";

    $sql = "SELECT * FROM personer WHERE ID IN 
        (SELECT PersonID FROM personkildekobling WHERE KildePersonID IN 
        (SELECT p1.ID FROM personerfrakilder p1 INNER JOIN
        (SELECT KildeID, KildeType, personkildekobling.KildePersonID FROM personerfrakilder 
        INNER JOIN personkildekobling ON personkildekobling.KildePersonID = personerfrakilder.ID
        WHERE personkildekobling.PersonID = $PersonID ORDER BY personkildekobling.PersonID) p2
        ON
        p1.KildeID = p2.KildeID
        AND p1.KildeType = p2.KildeType
        AND p1.ID != p2.KildePersonID));";


    echo "<h3>Relaterte personer</h3>";    


    $result = ($connection-> query($sql));

    if($result-> num_rows > 0) {
        echo "<table class='table table-striped table-bordered'>";
        echo "<th></th>";    
        tableHeader("personer");

        while($row = $result-> fetch_assoc()) {
            echo "<tr>";
            $ID = $row["ID"];
            $link = "showLinks.php?ID=$ID";
            echo "<td><a href='$link' class='btn btn-secondary'>Se personen</a></td>";
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
        echo "</tr>";
        }
        echo "</table>";
    
    }
    else {
        echo "Ingen personer linket til relaterte kilder. Se Relaterte kilder under.";
    }
    echo "<br>";
    
    echo "<h3>Relaterte kilder</h3>";    
    
    $sql = "SELECT p1.* FROM personerfrakilder p1 INNER JOIN
    (SELECT KildeID, KildeType, personkildekobling.KildePersonID FROM personerfrakilder INNER JOIN personkildekobling ON personkildekobling.KildePersonID = personerfrakilder.ID WHERE personkildekobling.PersonID = $PersonID ORDER BY personkildekobling.PersonID) p2
    ON
    p1.KildeID = p2.KildeID
    AND p1.KildeType = p2.KildeType
    AND p1.ID != p2.KildePersonID;";

    $result = ($connection-> query($sql));

    if($result-> num_rows > 0) {
        echo "<table class='table table-striped table-bordered table-responsive'>";
        echo "<th></th>";    
        tableHeader("personerfrakilder");

        while($row = $result-> fetch_assoc()) {
            echo "<tr>";
            $table = $row["KildeType"];
            $ID = $row["KildeID"];
            $link = "result.php?table=$table&ID=$ID";
            echo "<td><a href='$link' class='btn btn-secondary'>Se kilden</a></td>";
            foreach ($row as &$value) {
                echo "<td>" . $value . "</td>";
            }
        echo "</tr>";
        }
        echo "</table>";
    
    }
    else {
        echo "Ingen kilder.";
    }
    echo "<br>";
}
else {header("Location:searchPerson.php");}
?>
</div>
</body>
</html>



